<?php


/**
######################################
# papoo Version 2.0                  #
# (c) Carsten Euwens 2004            #
# Authors: Carsten Euwens            #
# http://www.papoo.de                #
# Internet                           #
######################################
# PHP Version 4.2                    #
######################################

Dieses Programm ist freie Software. Sie knnen es unter den
Bedingungen der GNU General Public License, wie von der Free
Software Foundation verffentlicht, weitergeben und/oder
modifizieren, entweder gem Version 2 der Lizenz oder
(nach Ihrer Option) jeder spteren Version.

Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
sogar ohne die implizite Garantie der MARKTREIFE oder der
VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie
in der GNU General Public License.

Sie sollten eine Kopie der GNU General Public License
zusammen mit diesem Programm erhalten haben. Falls nicht, s
chreiben Sie an die Free Software Foundation, Inc., 59
Temple Place, Suite 330, Boston, MA 02111-1307, USA.


*/

class artikel {

	/**
	Konstruktor, alle wichtigen Variablen initialisieren
	*/

	function artikel() {

		/**
		Klassen globalisieren
		*/

		// cms Klasse einbinden
		global $cms;
		$this->cms= & $cms;
		// einbinden des Objekts der Datenbak Abstraktionsklasse ez_sql
		global $db;
		$this->db= & $db;
		// Messages einbinden
		global $message;
		$this->message= & $message;
		// User Klasse einbinden
		global $user;
		$this->user= & $user;
		// weitere Seiten Klasse einbinden
		global $weiter;
		$this->weiter= & $weiter;
		// inhalt Klasse einbinden
		global $content;
		$this->content= & $content;
		// Suchklasse einbinden
		global $searcher;
		$this->searcher= & $searcher;
		// checkedblen Klasse einbinde
		global $checked;
		$this->checked= & $checked;
		// Zhlen Klasse
		global $counter;
		$this->counter= & $counter;
		// Ersetzungsklasse einbinden
		global $replace;
		$this->replace= & $replace;
		// Mail Klasse einbinden
		global $mail_it;
		$this->mail_it= & $mail_it;
		// bbcode Klasse einbinden
		global $bbcode;
		$this->bbcode= & $bbcode;
		// Diverse-Klasse einbinden
		global $diverse;
		$this->diverse= & $diverse;
		// Spamschutz-Klasse einbinden
		global $spamschutz;
		$this->spamschutz= & $spamschutz;

	}

	/*
	Hauptfunktion, Ergebnisse produzieren
	*/

	function make_inhalt() {

		// Wenn der Artikel gesendet werden soll id bergeben
		if (!empty ($this->checked->reporeid_send)) {
			$this->checked->reporeid= $this->checked->reporeid_print;
		}

		// wenn Suche dann suchen
		if (!empty ($this->checked->search)) {
			$this->content->template['table_data']= $this->find_artikel($this->checked->search);
		}

		// Wenn nicht dann Standard
		else {

			// wenn menuid leer ist dann Variable setzen
			/**if (empty ($this->checked->menuid) and @ defined(intranet))
			$this->checked->menuid= 2;
			*/
			if (empty ($this->checked->menuid))
			$this->checked->menuid= 1;
			if (empty ($this->checked->reporeid)) {
				$this->checked->reporeid= "";
			}
			// Unterseite oder Artikel ausgewhlt, dann anzeigen
			if ($this->checked->menuid != '1' or $this->checked->reporeid != "" ) {

				// Artikel aus der Datenbank fischen
				$this->content->template['table_data']= $this->check_artikel();
			}
			// wenn Startseite, dann Startseite anzeigen
			else {
				// startseite erzeugen
				$this->content->template['table_data']= $this->make_start();
				$this->content->template['startseite']= "ok";
			}

			$this->content->template['menuid_aktuell']=$this->checked->menuid;
		}
	}

	/*
	Datenbank durchsuchen und Ergenisse auswerfen
	*/

	function find_artikel($search) {

		// Datenbank dursuchen und Ergebnisse abholen
		$ergebniss= $this->searcher->do_search($this->checked->search);

		// Anzahl der Ergebnisse aus der Suche Eigenschaft bergeben
		$this->weiter->result_anzahl= $this->searcher->result_anzahl;

		// setzen, dass Suche ausgewhlt ist
		$this->content->template['such']= 1;

		// Suchwort(e) bergeben
		$this->suchwort= $this->checked->search;

		// wenn weitere Ergebnisse angezeigt werden knnen
		$this->weiter->weiter_link= $this->cms->webverzeichnis."/index.php?menuid=".$this->checked->menuid;

		// wenn es sie gibt, weitere Seiten anzeigen
		$what= "search";
		$this->weiter->do_weiter($what);

		// zuweisen der Inhalte aus der Scuhfunktion als array
		return $ergebniss;
	}
	/**
	* @return Artikel senden
	* @desc Diese Methode versendet einen Artikel
	*/
	function send_artikel() {

		// Daten aus der Datenbank fischen
		$select= "SELECT * FROM ".$this->cms->papoo_repore.",".$this->cms->papoo_language_article." WHERE";
		$select .= "  publish_yn='1' AND allow_publish='1'  AND publish_yn_intra='0' AND allow_publish='1' AND reporeID LIKE '".$this->db->escape($this->checked->reporeid)."' AND reporeID=lan_repore_id AND lang_id='".$this->cms->lang_id."' ORDER BY reporeID DESC";
		// Daten in ein Array weisen
		$result= $this->db->get_results($select);

		// Array durchgehen
		foreach ($result as $roweins) {
			$inhalt= $roweins->header.$roweins->lan_teaser.$roweins->article_lan;
			$menuid_send= $roweins->cattextid;
		}

		// Entscheidung nach $what wenn Link dann nur Link senden
		if ($this->checked->what == "link") {
			$inhalt= "";
		}
		//  ansonsten Text komplett senden
		if ($this->checked->what == "text") {
			// nix
		}
		$inhalt= $this->checked->comment_inhalt."\n".$inhalt;
		$send= $this->mail_it->send_mail($menuid_send, $this->checked->reporeid, $this->checked->title_send, $this->checked->comment_mail, $this->checked->empfang_mail, $inhalt);
		// wenn senden geklappt hat
		if ($send == "ok") {
			$location_url= $_SERVER[PHP_SELF]."?menuid=".$this->checked->menuid."&reporeid=".$this->checked->reporeid_print."&gesendet=1";
			if ($_SESSION['debug_stopallredirect'])
			echo '<a href="'.$location_url.'">Weiter</a>';
			else
			header("Location: $location_url");
			exit;
		}
		// wenn nicht dann Auswahl erneut anzeigen
		elseif ($send == "nok") {
			//header("Location;index.php?reporeid_send=1&reporeid_print=$reporeid&error=1");
			$location_url= "index.php?reporeid_send=1&reporeid_print=$reporeid&error=1";
			if ($_SESSION['debug_stopallredirect'])
			echo '<a href="'.$location_url.'">Weiter</a>';
			else
			header("Location: $location_url");
			exit;
		}
	}

	/**
	* @return Artikel senden
	* @desc Diese Methode erstellt die Maske fr das versenden eines Artikelsl fr den Output ins Template
	*/
	function send_artikel_mask() {

		// Artikel soll gesendet werden -> Template
		$this->content->template['articlesend']= 1;

		// Daten aus der Datenbank holen
		$select= "SELECT * FROM ".$this->cms->papoo_repore.",".$this->cms->papoo_language_article." WHERE";
		$select .= "  publish_yn='1' AND allow_publish='1'  AND publish_yn_intra='0' AND allow_publish='1' AND reporeID = '".$this->db->escape($this->checked->reporeid_print)."' AND reporeID=lan_repore_id AND lang_id='".$this->cms->lang_id."' ORDER BY reporeID DESC";

		$result= $this->db->get_results($select);
		$this->content->template['empfang_mail']= $this->checked->empfang_mail;
		$this->content->template['comment_mail']= $this->checked->comment_mail;
		if ($this->checked->what == "link") {
			$this->content->template['checked_link']= "checked=\checked\"";
		}
		if ($this->checked->what == "text") {
			$this->content->template['checked_text']=  "checked=\checked\"";
		}
		$this->content->template['comment_inhalt']= $this->checked->comment_inhalt;

		//print_r($result);
		// Daten  zuweisen -> Template
		if (!empty ($result)) {
			foreach ($result as $roweins) {
				$texteins= "<p>".$roweins->lan_teaser."</p>";
				$islinkmehr= $roweins->header;
				$this->content->template['reporeid_print']= $this->checked->reporeid_print;
				$this->content->template['islink_send']= $islinkmehr;
				$this->content->template['text_send']= $texteins;

				// Error 1, Email nicht valide
				if ($this->error == 1) {
					$message->message_print= $this->message->error_1;
				}
			}
		}
	}

	/**
	* @return $table_data
	* @desc Diese Methode erstellt den Artikel fr den Output ins Template
	*/
	function make_artikel() {
		

		// Daten aus der Datenbank holen fr den jeweiligen Menupunkt
		$result= $this->get_artikel($this->checked->menuid);

		// Nur ein Eintrag vorhanden -> Template
		$this->content->template['eintrag']= 1;

		//wenn downgeloadet werden soll, downloaden
		$this->make_download();

		// Artikel darstellen ermglichen -> Template
		$this->content->template['article']= 1;
		$table_data= array ();
		$islink_ok= "ok";
		//Artikel einen hochzhlen
		if (!empty ($this->checked->reporeid)) {
			$sql= "UPDATE ".$this->cms->papoo_repore." SET count=count+1 WHERE reporeID='".$this->checked->reporeid."' ";
			$this->db->query($sql);
			$islink_ok= "";
		} else {
			$select= " SELECT COUNT(reporeID) FROM ".$this->cms->papoo_repore." WHERE";
			$select .= " cattextid='".$this->db->escape($this->checked->menuid)."'";
			$select .= "";
			$res= $this->db->get_var($select);
			if ($res == 1) {
				$sql= "UPDATE ".$this->cms->papoo_repore." SET count=count+1 WHERE cattextid='".$this->db->escape($this->checked->menuid)."' ";
				$this->db->query($sql);
				$islink_ok= "";

			}

		}
		$islink_ok;

		// Daten bearbeiten und zuweisen fr das Template
		//print_r($result);
		if (!empty ($result)) {
			foreach ($result as $roweins) {

				// Usernamen raussuchen ###
				$queryuser= "SELECT * FROM ".$this->cms->papoo_user." WHERE userid='$roweins->dokuser'";
				$resultusi= $this->db->get_results($queryuser);
				// Wenn nicht leer dann zuweisen
				if (!empty ($resultusi)) {
					foreach ($resultusi as $rowuser) {
						// Variablen zuweisen fr das Template
						$this->author= $rowuser->username;
						$this->content->template['usernameid']= $this->user->username;
					}
				}
				$this->repoex=$reporeid= $roweins->reporeID;


				// Es existiert ein Eintrag -> Template
				$this->eintrag= 1;

				//zhlen und Variable erstellen fr Template
				$count= $roweins->count;
				//Anzahl der Besucher insgesamt
				$this->counter->get_count();

				//Wenn kommentiert werden darf
				$this->content->template['allow_comment2']= $roweins->allow_comment;

				// Text aus der Datenbank zuweisen
				$texteins= $roweins->lan_article;
				
				//Donwloads zhlen
				$this->countd=$row->count_download;

				// Hier die Ersetzung der Download-Links
				$texteins= $this->replace_downloadlinks($texteins);

				// Wenn mod_rewrite aktiviert ist, Links ndern
				//edited by b.legt: Anpassung an Installation in Unterverzeichnis
				// !!! weiss nicht ob das korrekt ist die Dinger immer zu ersetzen. Bei mir schient es so aber zu funktionieren.

				// Ende edited by b.legt

				//Wenn der Teaser im Artikel angezeigt werden soll
				if ($roweins->teaser_atyn==1){
					// Teaser markieren

					$texteins= "<p>".$roweins->teaser_bild_html."".$roweins->lan_teaser."</p>".$texteins;
				}
				$texteins= $this->diverse->do_pfadeanpassen($texteins);

				// Linktext fr mehr ber ...
				if (trim($roweins->lan_teaser_link) == "") {
					$islink= $roweins->header;
				} else {
					$islink= $roweins->lan_teaser_link;
				}

				if ($roweins->uberschrift_hyn==1){
					// Slashes aus der berschrift entfernen
					$uberschrift= $roweins->header;
				}

				// id fr den Ausdruck bergeben
				$this->content->template['reporeid_print']= $reporeid;
				//Editieren checken
				$this->check_edit($reporeid);
				//extra Metadaten zuweisen
				if (!empty($roweins->lan_metatitel))
				$this->content->template['site_title']=$roweins->lan_metatitel;
				else
				// Titel zuweisen
				$this->content->template['site_title']= $uberschrift;
				if (!empty($roweins->lan_metadescrip))
				$this->content->template['description']=$roweins->lan_metadescrip;
				if (!empty($roweins->lan_metakey))
				$this->content->template['keywords']=$roweins->lan_metakey;



				// Titel fr Kommentar
				$this->content->template['comment_title']= $uberschrift;

				// Slashes entfernen aus dem Artikel
				//$texteins = stripslashes($texteins);

				// Daten in ein Array zuweisen
				$table_data= array ();
				array_push($table_data, array ('uberschrift' => $uberschrift, 'islink' => $islink, 'islink_ok' => $islink_ok, 'text' => $texteins, 'zeitstempel' => $roweins->timestamp, 'wie_oft' => $count, 'author' => $this->author, 'reporeid' => $reporeid));

			}
		}
		return $table_data;
	}

	// Download-Link-KrimsKrams
	// =========================
	function replace_downloadlinks($text= "") {
		if ($text) {
			// 1. Menu-ID und Repore-ID in die Download-Links einfgen
			$menuid= $this->checked->menuid;
			$reporeid= $this->checked->reporeid;
			// reporeid mit 0 belegen, falls nicht vorhanden
			if ($reporeid < 1)
			$reporeid= "0";
			//echo "Menu: ".$menuid. "; Re-ID: ".$reporeid."; <br />";
			$text= eregi_replace("xxmenuidxx", $menuid, $text);
			$text= eregi_replace("xxreporeidxx", $reporeid, $text);
			//echo $text."<br />";

			// 2. Feststellen ob Download-Links existieren
			$downloadlink_array= $this->find_downloadlinks($text);
			//print_r($downloadlink_array);
			if ($downloadlink_array) {
				// 3. Wenn Download-Links existieren, diese ersetzen und evtl. Downlaod-Text hinten anfgen
				foreach ($downloadlink_array as $link_array) {
					if ($this->check_download_rights($link_array[2])<1){
						$nachlinktext= " - <strong class=\"error\">Sie haben keine Berechtigung zum Download</strong>";
					}
					else {
						$nachlinktext= $this->get_downloadlink_text($link_array[2]);
					}


					$old_link= preg_quote($link_array[0]);

					$new_link= $link_array[0].$nachlinktext;
					//Downloads in einem neuen Fenster
					$new_link=eregi_replace(" href="," title=\"Download in einem neuen Fenster\" target=\"_blank\" href=",$new_link);

					$text= eregi_replace($old_link, $new_link, $text);
				}
			}
		}
		return $text;
	}

	function find_downloadlinks($text) {
		$download_links= "";
		$pattern= "/(\<a .*?downloadid=([0-9]*).*?\>)(.*?)(\<\/a\>)/";
		$anzahl= preg_match_all($pattern, $text, $download_links, PREG_SET_ORDER);
		//echo "Der Text hat insgesamt ".$anzahl." Download-Links.<br />";
		if (!empty ($download_links))
		return $download_links;
		else
		return false;
	}

	function get_downloadlink_text($download_id= 0) {
		if ($download_id) {
			// Daten aus Tabelle download holen
			$query= sprintf("SELECT %s, %s, %s FROM %s, %s WHERE %s.downloadid='%d' AND %s.download_id='%d'", "ROUND(".$this->cms->papoo_download.".downloadgroesse / 1024) AS filesize", $this->cms->papoo_download.".wieoft", "DATE_FORMAT(".$this->cms->papoo_download.".zeitpunkt, '%e.%c.%Y') AS datum", 
			$this->cms->papoo_download, 
			$this->cms->papoo_language_download, 
			$this->cms->papoo_download, 
			$download_id, 
			$this->cms->papoo_language_download, 
			$download_id
			);
			//echo "QUERY: ".$query."<br />";
			$result= $this->db->get_results($query);
			//print_r($result);
			if ($this->countd==1){
			if (!empty ($result)) {
				$text= "<small> (Gre: ".$result[0]->filesize."kB; Downloads bisher: ".$result[0]->wieoft."; Letzter Download am: ".$result[0]->datum.")</small>";
			}
			}
		}

		//
		return $text;
	}
	// Ende Download-Link-KrimsKrams
	// =============================

	/**
	Kommentare anzeigen und in die Datenbank schreiben
	*/
	function do_comment() {

		if (empty ($this->checked->uebermittelformular)) {
			$this->checked->uebermittelformular= "";
		}

		$inhalt= "";
		// Kommentare sind erlaubt
		$this->content->template['erlaubt']= 1;
		// Wenn das Formular fr das eintragen eines Beitrages bettigt wurde...
		if ($this->checked->uebermittelformular) {
			//Username checken und wenn ok dann bergeben
			if (!empty($this->user->userid) and $this->user->userid!=11){
				$this->checked->neuvorname=$this->user->username;
			}
			// Wenn sowohl ein Thema eingegeben ist, als auch ein Inhalt
			if (empty ($this->checked->neuvorname) || empty ($this->checked->formthema) || empty ($this->checked->inhalt) || $this->spamschutz->is_spam)
			// Daten fehlen oder Spamcode falsch
			{
				// Fehler setzen
				$this->content->template['fehler']= "Sie haben einen Fehler in Ihren Angaben";
				// Daten an Template durchreichen.
				$this->content->template['author']= $this->checked->neuvorname;
				$this->checked->formthema=eregi_replace("Kommentar zu","",$this->checked->formthema);
				$this->content->template['thema']= $this->checked->formthema;
				$this->content->template['inhalt']= $this->checked->inhalt;
				//echo "--";
			}
			else {


				// Datum erstellen
				$heute= date("j.n.Y  G:i:s");

				$blacklist= new blacklist();
				$truethema= $blacklist->do_blacklist($this->checked->formthema);
				$trueinhalt= $blacklist->do_blacklist($this->checked->inhalt);

				// Aus Sicherheitsgrnden < und > Zeichen ersetzen
				$this->checked->formthema= str_replace("<", "&lt;", $this->checked->formthema);
				$this->checked->formthema= str_replace(">", "&gt;", $this->checked->formthema);
				$this->checked->inhalt= str_replace("<", "&lt;", $this->checked->inhalt);
				$this->checked->inhalt= str_replace(">", "&gt;", $this->checked->inhalt);

				// Ordnung eingeben (nicht mehr ntig)
				//$orderstr = "0";

				// Wenn userid leer, dann Gast oder jeder eingeben
				if ($this->user->userid == 0 or $this->user->userid == 11) {
					$userid_drin= 11;
					$usernameguest= $this->checked->neuvorname;
				} else {
					$userid_drin= $this->user->userid;
				}

				// Eintrag fr die Datenbank erstellen
				$query= sprintf("INSERT INTO %s
																	(comment_article, zeitstempel, forumid, parentid, rootid, userid, 
																	thema, messagetext, level, ordnung, username_guest) 
																	VALUES('%d','%s', '10', '0',  '0',' %d', '%s', '%s', '0', '0','%s')", $this->cms->papoo_message, $this->checked->reporeid, $this->db->escape($heute), $userid_drin, $this->db->escape($this->checked->formthema), $this->db->escape($this->checked->inhalt), $usernameguest);

				/* nur wenn keine Blacklisteintrge drin sind, auch eintragen,
				* ansonsten nichts eintragen, luft ins Leere
				*
				*/
				if ($truethema == "ok" and $trueinhalt == "ok") {
					// in die Datenbank eintragen
					$this->db->query($query);
				}

				// neu laden und inhalt leeren
				$location_url= $_SERVER['PHP_SELF']."?menuid=".$this->checked->menuid."&reporeid=".$this->checked->reporeid;
				if ($_SESSION['debug_stopallredirect'])
				echo '<a href="'.$location_url.'">Weiter</a>';
				else
				header("Location: $location_url");
				exit ();

			}

		}
		if (empty ($this->checked->reporeid)) {
			$select= " SELECT reporeID FROM ".$this->cms->papoo_repore." WHERE";
			$select .= " cattextid='".$this->db->escape($this->checked->menuid)."'";
			$select .= " LIMIT 1";
			$res= $this->db->get_var($select);
			// Kommentare auswhlen
			$sqlcomment= "SELECT * FROM ".$this->cms->papoo_message." WHERE comment_article='".$res."' ORDER BY msgid ASC ";
		} else {
			// Kommentare auswhlen
			if (!is_numeric($this->checked->reporeid)) {
				$this->checked->reporeid= 88;
			}
			if (empty($sqlcomment)){
				$sqlcomment= "SELECT * FROM ".$this->cms->papoo_message." WHERE comment_article='".$this->db->escape($this->checked->reporeid)."' ORDER BY msgid ASC ";
			}
		}

		$this->content->template['username_neu_comment']=$this->user->username;
		// Kommentare auslesen
		$resultcomment= $this->db->get_results($sqlcomment);

		// Wenn welche vorhanden sind, anzeigen ok setzen
		if (!empty ($resultcomment)) {
			$this->content->template['comment_ok']= "ok";
		}
		// Array erstellen
		$comment_data= array ();

		// Wenn Resultate vorliegen
		if (!empty ($resultcomment)) {

			// fr jedes Ergebniss durchloopen
			foreach ($resultcomment as $rowcom) {

				// decodieren
				$messagetextcom= ($rowcom->messagetext);

				// Escape entfernen
				//$messagetextcom = stripslashes($messagetextcom);

				// Usernamen raussuchen
				$sqlgetuser= "SELECT username FROM ".$this->cms->papoo_user." WHERE userid='$rowcom->userid' LIMIT 1";

				// Username zuweisen
				$resultusercom= $this->db->get_results($sqlgetuser);

				// Wenn es nicht leer ist Username zuweisen frs Template
				if (!empty ($resultusercom) and $rowcom->userid != "11") {

					foreach ($resultusercom as $rowusercom) {

						if (!empty ($rowusercom->username)) {
							$username_comment= $rowusercom->username;
						} else {
							$username_comment= "Gast";
						}
					}
				} else {
					$username_comment= $rowcom->username_guest;
				}
				// Daten in ein Array weisen
				# SPRACHAUSGABE edited by b.legt
				#array_push($comment_data, array ('text' => $messagetextcom, 'zeitstempel' => $rowcom->zeitstempel, 'thema' => $rowcom->thema, 'username_comment' => $username_comment,));
				# die msgid muss fuer die Sprachausgabe mit in das array gepusht werden
				array_push($comment_data, array ('msgid' => $rowcom->msgid, 'text' => $messagetextcom, 'zeitstempel' => $rowcom->zeitstempel, 'thema' => $rowcom->thema, 'username_comment' => $username_comment));
				# / SPRACHAUSGABE edited by b.legt

			}
			// Array in Eigenschaft weisen
			$this->content->template['comment_data']= $comment_data;
		}
		// Ende Kommentar #####
	}
	/**
		Kommentare anzeigen und in die Datenbank schreiben
		*/
	function do_guestbook() {
		$inhalt= "";

		// Kommentare sind erlaubt
		$this->content->template['erlaubt']= 1;
		// menuid zuweisen
		$this->content->template['formmenuid']= $this->checked->menuid;
		// Wenn das Formular fr das eintragen eines Beitrages bettigt wurde...
		if (empty ($this->checked->uebermittelformular)) {
			$this->checked->uebermittelformular= "";
		}
		if ($this->checked->uebermittelformular) {
			// !!! Einbau Spam-Kontrolle Teil 2
			// Test ob Daten fehlen; Test auf Spam;

			if (empty ($this->checked->author) || empty ($this->checked->thema) || empty ($this->checked->inhalt) || $this->spamschutz->is_spam)
			// Daten fehlen oder Spamcode falsch
			{
				// Fehler setzen
				$this->content->template['fehler']= "Sie haben einen Fehler in Ihren Angaben";
				// Daten an Template durchreichen.
				$this->content->template['author']= $this->checked->author;
				$this->content->template['thema']= $this->checked->thema;
				$this->content->template['inhalt']= $this->checked->inhalt;
				//echo "--";
			}
			// Daten sind OK, in Datenbank eintragen
			else {

				// Datum erstellen
				$heute= date("j.n.Y  G:i:s");
				$blacklist= new blacklist();
				$truethema= $blacklist->do_blacklist($this->checked->formthema);
				$trueinhalt= $blacklist->do_blacklist($this->checked->inhalt);

				// Aus Sicherheitsgrnden < und > Zeichen ersetzen
				$this->checked->formthema= str_replace("<", "&lt;", $this->checked->formthema);
				$this->checked->formthema= str_replace(">", "&gt;", $this->checked->formthema);
				$this->checked->inhalt= str_replace("<", "&lt;", $this->checked->inhalt);
				$this->checked->inhalt= str_replace(">", "&gt;", $this->checked->inhalt);

				// Ordnung eingeben (nicht mehr ntig)
				//$orderstr = "0";

				// Wenn userid leer, dann Gast oder jeder eingeben
				if ($this->user->userid == 0 or $this->user->userid == 11) {
					$userid_drin= 11;
				} else {
					$userid_drin= $this->user->userid;
				}

				// Eintrag fr die Datenbank erstellen
				$query= sprintf("INSERT INTO %s
																	(comment_article, zeitstempel, forumid, parentid, rootid, userid, 
																	thema, messagetext, level, ordnung, username_guest) 
																	VALUES(%d,'%s', '20', '0',  '0', %d, '%s','%s', '0', '0','%s')", $this->cms->papoo_message, $this->checked->reporeid, $this->db->escape($heute), $userid_drin, $this->db->escape($this->checked->thema), $this->db->escape($this->checked->inhalt), $this->db->escape($this->checked->author));

				/* nur wenn keine Blacklisteintrge drin sind, auch eintragen,
				* ansonsten nichts eintragen, luft ins Leere
				*
				*/
				if ($truethema == "ok" and $trueinhalt == "ok") {
					// in die Datenbank eintragen
					$this->db->query($query);
				}

				// neu laden und inhalt leeren
				// Im Gstebuch gibt es keine ReporeID und auch kein inhaltrein, also was soll das ???
				//$location_url= $_SERVER['PHP_SELF']."?menuid=".$this->checked->menuid."&reporeid=".$this->checked->reporeid."&inhaltrein=";
				$location_url= $_SERVER['PHP_SELF']."?menuid=".$this->checked->menuid."&uebermittelformular=";

				if ($_SESSION['debug_stopallredirect']) echo '<a href="'.$location_url.'">Weiter</a>';
				else header("Location: $location_url");

				exit ();

			}
		} else {

			// Gstebucheintrge auswhlen
			$sqlcomment= "SELECT COUNT(msgid) FROM ".$this->cms->papoo_message." WHERE  forumid='20' ORDER BY msgid DESC ";
			// Kommentare auslesen
			$resultanzahl= $this->db->get_var($sqlcomment);

			// Gstebucheintrge auswhlen
			$sqlcomment= "SELECT * FROM ".$this->cms->papoo_message." WHERE  forumid='20' ORDER BY msgid DESC ".$this->cms->sqllimit."";
			// Kommentare auslesen
			$resultcomment= $this->db->get_results($sqlcomment);

			// Wenn welche vorhanden sind, anzeigen ok setzen
			if (!empty ($resultcomment)) {
				$this->content->template['comment_ok']= "ok";
			}
			// Array erstellen
			$comment_data= array ();

			// Wenn Resultate vorliegen
			if (!empty ($resultcomment)) {

				// fr jedes Ergebniss durchloopen
				foreach ($resultcomment as $rowcom) {

					// decodieren
					$messagetextcom= ($rowcom->messagetext);

					// Escape entfernen
					//$messagetextcom = stripslashes($messagetextcom);

					// Usernamen raussuchen
					if ($rowcom->userid != 11) {
						$sqlgetuser= "SELECT username FROM ".$this->cms->papoo_user." WHERE userid='$rowcom->userid' LIMIT 1";

						// Username zuweisen
						$resultusercom= $this->db->get_results($sqlgetuser);

						// Wenn es nicht leer ist Username zuweisen frs Template
						if (!empty ($resultusercom)) {
							foreach ($resultusercom as $rowusercom) {
								if (!empty ($rowusercom->username)) {
									$username_comment= $rowusercom->username;
								} else {
									$username_comment= "Gast";
								}
							}
						} else {
							$username_comment= "Gast";
						}
					} else {
						$username_comment= "_".$rowcom->username_guest;
					}
					// Daten in ein Array weisen
					// SPRACHAUSGABE edited by b.legt
					// die msgid muss fuer die Sprachausgabe mit in das array gepusht werden
					array_push($comment_data, array ('msgid' => $rowcom->msgid, 'text' => $messagetextcom, 'zeitstempel' => $rowcom->zeitstempel, 'thema' => $rowcom->thema, 'username_comment' => $username_comment));
					// SPRACHAUSGABE edited by b.legt

				}
				// Array in Eigenschaft weisen
				$this->content->template['comment_data']= $comment_data;

				// zhlen wieviele Artikel existieren
				$this->weiter->result_anzahl= $resultanzahl;
				// Adresse des Links bergeben
				$this->weiter->weiter_link= "guestbook.php?menuid=".$this->checked->menuid."";
				if ($this->cms->mod_rewrite == 2) {
					$this->weiter->weiter_link= "guestbook/menuid/".$this->checked->menuid."";
				}
				$what= "teaser";
				// Links zu weiteren Seiten anzeigen
				$this->weiter->do_weiter($what);
			}
		}
	}

	/**
	* @return $result
	* @desc Diese Methode gibt den Artikel oder die Startseite aus.
	*/
	function check_artikel() {

		// Standard fr Suchvariable ...
		#$this->content->template['search']= "eingeben";
		$result= "";
		$sendneu= "no";

		if (empty ($this->checked->send_artikel)) {
			$this->checked->send_artikel= "";
		}

		//Artikel wurde erfolgreich versendet
		if (!empty ($this->checked->gesendet)) {
			$this->content->template['gesendet']="1";
		}

		// Artikel wird jetz gesendet
		if ($this->checked->send_artikel == "Senden" and $this->spamschutz->is_spam == false) {
			$this->send_artikel();

		}

		// Artikel wird nicht gesendet da Spam???
		if ($this->checked->send_artikel == "Senden" and $this->spamschutz->is_spam == true) {
			$sendneu= "yes";
			$this->content->template['error_comment']= "Bitte berprfen Sie Ihre Eingaben.";

		}

		if (empty ($this->checked->reporeid_send)) {
			$this->checked->reporeid_send= "";
		}
		// Wenn Artikel senden ausgewhlt ist , Eingabemaske anzeigen
		if ($this->checked->reporeid_send != "" or $sendneu == "yes") {

			$this->send_artikel_mask();
		} else {
			// Wir sind nicht auf der Startseite
			if ($this->checked->menuid != '1' or ($this->checked->menuid == 1 and $this->checked->reporeid != "")) {
				// Es ist kein einzelner Artikel ausgewhlt
				if ($this->checked->reporeid == "") {

					// zhlen wieviele Artikel existieren
					$this->weiter->result_anzahl= $this->get_anzahl();
					
					//Feststellen wieviele Artikel in Untermenupunkten sind
					#$anzahl2=$this->get_artikel_all($this->checked->menuid);
					#$this->weiter->result_anzahl=count($anzahl2);
					#$this->menuarray="";
					#if ($this->weiter->result_anzahl==0)
						#$this->weiter->result_anzahl=1;
					

					// Aber es existiert nur einer in der Datenbank fuer diesen Menueintrag
					if ($this->weiter->result_anzahl == 1) {

						// Daten aus der Datenbank holen fr den jeweiligen Menupunkt
						$result= $this->make_artikel();
						

						// Daten zurckgeben
						return $result;
					}

					// Es existieren mehr Eintrge fuer diesen Menupunkt; Eintrge mit Links anzeigen
					else {

						// Alle Artikel diese Menpunktes anzeigen mit teaser
						$teaser= $this->make_teaser();

						// Adresse des Links bergeben
						$this->weiter->weiter_link= "index.php?menuid=".$this->checked->menuid."";
						if ($this->cms->mod_rewrite == 2) {
							$this->weiter->weiter_link= "index/menuid/".$this->checked->menuid;
						}
						$what= "teaser";
						// Links zu weiteren Seiten anzeigen
						$this->weiter->do_weiter($what);
						// Daten zurckgeben
						return $teaser;
					}
				}
				// Es ist ein einzelner Eintrag ausgewhlt
				else {
					// Daten aus der Datenbank holen fr den jeweiligen Menupunkt
					$result= $this->make_artikel();
					//Edit check
					$this->check_edit($this->checked->reporeid);

					// Daten zurckgeben
					return $result;

				}
			}
		}
		return $result;

	}

	/*
	Wir sind auf der language_stammseite, alle Eintrge mit Links anzeigen ...
	*/

	function make_start() {

		// einbinden der user Daten
		$table_data= array ();

		//wenn ein Download gemacht werden soll
		$this->make_download();

		// Besucher zhlen,
		$this->counter->count();



		// sollen Artikel auf der Startseite angezeigt werden? (2==ja)
		if ($this->cms->artikel_yn == 2) {
			// Artikel aus der Datenbank holen und als Teaser Liste bergeben
			$result_teaser= $this->make_teaser();

			//wenn weitere Seiten vorhanden sind...
			$this->weiter->weiter_link= "index.php?menuid=".$this->checked->menuid."";
			if ($this->cms->mod_rewrite == 2) {
				$this->weiter->weiter_link= "index/menuid/".$this->checked->menuid;
			}
			$what= "teaser";
			$this->weiter->do_weiter($what);
			return $result_teaser;

		}

		// sollen Artikel auf der Startseite angezeigt werden? (1==nein)
		if ($this->cms->artikel_yn == 1) {
			// Daten zuweisen...
			$top_text= $this->diverse->do_pfadeanpassen($this->cms->top_text);
			array_push($table_data, array ('text' => $top_text));

			return $table_data;
		}
	}

	/**
			 * Sicherheitsabfrage formulieren, ob die Datei vom User downgeloader
			 * werden darf oder nicht.
			 */ 

	function check_download_rights($id){

		$sql= "SELECT COUNT(downloadid) FROM ".$this->cms->papoo_download.",".$this->cms->papoo_lookup_download.",".$this->cms->papoo_lookup_ug."  WHERE ";
		$sql .= "downloadid='".$this->db->escape($id)."' ";
		$sql .= " AND userid='".$this->user->userid."' ";
		$sql .= " AND gruppenid=gruppen_id_id";
		$sql .= " AND downloadid=download_id_id";
		$sql .= " LIMIT 1";
		$sql .= "";
		$sql .= "";
		return $downok= $this->db->get_var($sql);
	}
	/**
	 * @descrip Den Download durchfhren
	 */

	function make_download() {

		if (empty ($this->checked->downloadid)) {
			$this->checked->downloadid= "";
		}

		if ($this->checked->downloadid != "") {

			$downok= $this->check_download_rights($this->checked->downloadid);
			// Wenn die rechte dazu existieren Datei downloaden
			if ($downok >= 1) {
				// Abfrage formulieren Downloads zhlen
				$sql= "UPDATE ".$this->cms->papoo_download." SET wieoft=wieoft+1 WHERE downloadid=".$this->db->escape($this->checked->downloadid)."";

				// Abfrage durchfhren
				$this->db->query($sql);

				// Downloaddatei rausholen
				$sql= "SELECT * FROM ".$this->cms->papoo_download." WHERE downloadid='".$this->db->escape($this->checked->downloadid)."'";
				$resultiert= $this->db->get_results($sql);
				// fr jedes Ergebnis durchgehen
				foreach ($resultiert as $rowdown) {
					// Filename berichtigen
					$filename= basename($rowdown->downloadlink);
					// Wenn die Datei grer als 450 kb ist Meta Refresh Download durchfhren, da ansonsten bei langsamen Verbindungen Timeout droht!! Im Zweifel sogar noch kleiner machen!!!
					if ($rowdown->downloadgroesse > 450000) {
						$refresh= "<meta http-equiv=\"refresh\" content=\"0; url=".$this->cms->webverzeichnis.$rowdown->downloadlink."\" />";
						$this->content->template['refresh']= $refresh;
					}
					// Datei unterhalb von 450 kb
					else {
						// Header zuweisen
						header("Pragma: public");
						header("Expires: 0");
						header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
						header("Content-Description: File Transfer");
						header("Accept-Ranges: bytes");
						//header("Content-Type: application/force-download");
						//header("Content-Type: application/download");
						// Wenn Opera oder MSIE auftauchen
						//if (preg_match('#Opera(/| )([0-9].[0-9]{1,2})#', getenv('HTTP_USER_AGENT')) or preg_match('#MSIE ([0-9].[0-9]{1,2})#', getenv('HTTP_USER_AGENT'))) {
						//	header("Content-Type: application/octetstream");
						//} else {
						//	header("Content-Type: application/octet-stream");
						//}

						// Mime-Type der Datei festestellen und Content-Type festlegen
						$fragmente= explode(".", $filename);
						$endung= $fragmente[count($fragmente) - 1];

						switch ($endung) {
							case "pdf" :
							header("Content-Type: application/pdf");
							break;
							case "zip" :
							header("Content-Type: application/zip");
							break;
							case "doc" :
							header("Content-Type: application/msword");
							break;
							case "txt" :
							header("Content-Type: text/plain");
							break;
							default :
							header("Content-Type: application/octet-stream");
						}

						header("Content-Length: $rowdown->downloadgroesse ");
						# header("Pragma: no-cache");
						/*
						$browser = $_ENV['HTTP_USER_AGENT'];
						if (preg_match('/MSIE 5.5/', $browser) || preg_match('/MSIE 6.0/', $browser)) {
						header('Content-Disposition:  filename="'.$this->cms->webverzeichnis.$filename.'"');
						if (preg_match('/pdf/', $filename)) {
						header('Content-Disposition: attachment; filename="'.$this->cms->webverzeichnis.$filename.'"');
						}
						} else {
						header('Content-Disposition: attachment; filename="'.$this->cms->webverzeichnis.$filename.'"');
						}
						*/
						header('Content-Disposition: attachment; filename='.$filename.'');

						// Send Content-Transfer-Encoding HTTP header
						// (use binary to prevent files from being encoded/messed up during transfer)
						header('Content-Transfer-Encoding: binary');

						// File auslesen
						@ readfile(".".$rowdown->downloadlink);

						// Wichtig, sonst gibt es Chaos!
						exit;
					}
					// Downloadid zurcksetzen
					$downloadid= "";
				}
			}
			// keine rechte zum Download anzeigen
			else {

			}

		}
		// Ende des Downloads #############
	}

	/*
	Anzahl aller Eintrge von Artikeln in der Datenbank raussuchen
	*/

	function get_anzahl() {

		if (empty ($this->checked->reporeid)) {
			// Keine Abfrage => like %
			$like_repo= "LIKE";
			$reporeid= "%";

			// wenn Startseite
			if ($this->checked->menuid == 1) {
				// kein Menuid Bezug in der sql Abfrage => like %
				$selectmenuid= "%";
				$like= "LIKE";
				// ABer Abfrage ob geteasert werden soll auf der Startseite
				$like_teas= "=";
				$teas= "2";
			}

			// NIcht Startseite
			else {
				//  Menuid Bezug in der sql Abfrage => =$menuid
				$selectmenuid= $this->db->escape($this->checked->menuid);
				$like= "=";
				// Keine Abfrage ob geteaset werden soll
				$like_teas= "LIKE";
				$teas= "%";
			}
		} else {
			//  Abfrage => = $reporeid
			$like_repo= "=";
			$like_teas= "LIKE";
			$teas= "%";
			$selectmenuid= "%";
			$like= "LIKE";

		}
		if (empty ($this->checked->reporeid)) {
			$this->checked->reporeid= "%";
		}
		// Gesamte Anzahl der Artikel aus der Datenbank raussuchen
		$select= "SELECT COUNT(DISTINCT reporeID) FROM ".$this->cms->papoo_repore.",".$this->cms->papoo_lookup_article.",".$this->cms->papoo_lookup_ug." WHERE";
		$select .= " publish_yn='1' AND publish_yn_intra='0' AND allow_publish='1'  AND";
		$select .= " teaser_list $like_teas '$teas'  AND cattextid $like '$selectmenuid' AND reporeID $like_repo '".$this->db->escape($this->checked->reporeid)."' ";
		$select .= " AND reporeID=article_id ";
		$select .= " AND gruppeid_id=gruppenid";
		$select .= " AND userid='".$this->user->userid."'";
		$select .= " ORDER BY reporeID DESC ";
		// reporeid wieder zurcksetzen
		if (eregi("%", $this->checked->reporeid)) {
			$this->checked->reporeid= "";
		}
		// ANzahl der Ergebnisse
		return $this->artikel_anzahl= $this->db->get_var($select);
	}

	/*
	* @return Artikel
	* @desc Artikel aus der Datenbank fischen und bergeben...
	*/

	function get_artikel($menuid= 1) {
		global $template;

		// wenn Gstebuch, dann
		if ($template == "guestbook.html") {
			// Kommentare anzeigen
			$this->do_guestbook();
		} else {
			// Kommentare anzeigen
			$this->do_comment();
		}
		// Wenn keine Reportage ausgewhlt ist
		if (empty ($this->checked->reporeid)) {
			// Keine Abfrage => like %
			$like_repo= "LIKE";
			$reporeid= "%";
			// wenn Startseite
			//if ($this->checked->menuid == 1)
			if ($menuid == 1) {
				// kein Menuid Bezug in der sql Abfrage => like %
				$selectmenuid= "%";
				$like= "LIKE";
				// ABer Abfrage ob geteaset werden soll auf der Startseite
				$like_teas= "=";
				$teas= "2";
			}
			// NIcht Startseite
			else {
				//  Menuid Bezug in der sql Abfrage => =$menuid
				//$selectmenuid = $this->checked->menuid;
				$selectmenuid= $menuid;
				$like= "=";
				// Keine Abfrage ob geteaset werden soll
				$like_teas= "LIKE";
				$teas= "%";
			}
		} else {
			//  Abfrage => = $reporeid
			$like_repo= "=";
			$like_teas= "LIKE";
			$teas= "%";
			$selectmenuid= "%";
			$like= "LIKE";

		}

		if (empty ($this->checked->reporeid)) {
			$this->checked->reporeid= "%";
		}

		// Artikel aus der Datenbank saugen, blog Version ... aktuellste werden zuerst angezeigt.
		$select= "SELECT DISTINCT header,lan_teaser, lan_article, reporeID, order_id, cattextid, timestamp,comment_yn, allow_comment, dokuser, count,count_download, lan_teaser_link,teaser_bild_html, lan_metatitel, lan_metadescrip, lan_metakey, teaser_atyn, uberschrift_hyn  FROM ".$this->cms->papoo_repore.", ".$this->cms->papoo_language_article.",".$this->cms->papoo_lookup_article.",".$this->cms->papoo_lookup_ug." WHERE";
		$select .= " publish_yn='1'  AND allow_publish='1' AND";
		$select .= " teaser_list $like_teas '$teas'  AND cattextid $like '$selectmenuid' AND reporeID $like_repo '".$this->db->escape($this->checked->reporeid)."' ";
		$select .= "AND reporeID=lan_repore_id AND lang_id='".$this->cms->lang_id."' ";
		$select .= " AND reporeID=article_id ";
		$select .= " AND gruppeid_id=gruppenid";
		$select .= " AND userid='".$this->user->userid."'";
		$select .= "  AND intranet_yn='".$this->cms->intranet_yn."'";
		$select .= " ORDER BY order_id DESC  ".$this->cms->sqllimit."";
		# echo $select;

		if (eregi("%", $this->checked->reporeid)) {
			$this->checked->reporeid= "";
		}

		return $this->result_artikel= $this->db->get_results($select);
	}

	/**
	 * @abstract Es ollen alle Artikel aus der Datenbank geholt werden, incl. alle EIntrge zu Untermenpunkten
	 *  
	 */
	function get_artikel_all($menuid= 1) {
		global $template;

		// wenn Gstebuch, dann
		if ($template == "guestbook.html") {
			// Kommentare anzeigen
			$this->do_guestbook();
		} else {
			// Kommentare anzeigen
			$this->do_comment();
		}
		// Wenn keine Reportage ausgewhlt ist
		if (empty ($this->checked->reporeid)) {
			// Keine Abfrage => like %
			$like_repo= "LIKE";
			$reporeid= "%";
			// wenn Startseite
			//if ($this->checked->menuid == 1)
			if ($menuid == 1) {
				// kein Menuid Bezug in der sql Abfrage => like %
				$selectmenuid= "%";
				$like= "LIKE";
				// ABer Abfrage ob geteaset werden soll auf der Startseite
				$like_teas= "=";
				$teas= "2";
			}
			// NIcht Startseite
			else {
				//  Menuid Bezug in der sql Abfrage => =$menuid
				//$selectmenuid = $this->checked->menuid;
				$selectmenuid= $menuid;
				$like= "=";
				// Keine Abfrage ob geteaset werden soll
				$like_teas= "LIKE";
				$teas= "%";
			}
		} else {
			//  Abfrage => = $reporeid
			$like_repo= "=";
			$like_teas= "LIKE";
			$teas= "%";
			$selectmenuid= "%";
			$like= "LIKE";

		}

		if (empty ($this->checked->reporeid)) {
			$this->checked->reporeid= "%";
		}

		//Rekursiv alle Untermenpunkte rausholen
		$this->get_all_menus($menuid);
		$this->result_artikel_all=array();

		// Artikel aus der Datenbank saugen, blog Version ... aktuellste werden zuerst angezeigt.
		if ($menuid == 1) {
			$this->menuarray=array();
			$this->menuarray[]="%";

		}
		if (!empty($this->menuarray)){
			//alle Menpunktge durchlaufen
			foreach ($this->menuarray as $selectmenuid) {


				$select= "SELECT DISTINCT header,lan_teaser, lan_article, reporeID, order_id, cattextid, timestamp,comment_yn, allow_comment, dokuser, count,count_download, lan_teaser_link,teaser_bild_html, lan_metatitel, lan_metadescrip, lan_metakey, teaser_atyn, uberschrift_hyn  FROM ".$this->cms->papoo_repore.", ".$this->cms->papoo_language_article.",".$this->cms->papoo_lookup_article.",".$this->cms->papoo_lookup_ug." WHERE";
				$select .= " publish_yn='1'  AND allow_publish='1' AND";
				$select .= " teaser_list $like_teas '$teas'  AND cattextid $like '$selectmenuid' AND reporeID $like_repo '".$this->db->escape($this->checked->reporeid)."' ";
				$select .= "AND reporeID=lan_repore_id AND lang_id='".$this->cms->lang_id."' ";
				$select .= " AND reporeID=article_id ";
				$select .= " AND gruppeid_id=gruppenid";
				$select .= " AND userid='".$this->user->userid."'";
				$select .= "  AND intranet_yn='".$this->cms->intranet_yn."'";
				$select .= " ORDER BY order_id DESC  ".$this->cms->sqllimit."";
				# echo $select;
				//Abfrage
				$ergebnis=$this->db->get_results($select);
				if (is_array($ergebnis)){
					$this->result_artikel_all=array_merge($this->result_artikel_all,$ergebnis);
				}
			}
		}

		if (eregi("%", $this->checked->reporeid)) {
			$this->checked->reporeid= "";
		}

		return $this->result_artikel_all;
	}

	/**
	 * rekursiv alle Untermenpunkte eines Menpunktes rausholen
	 */
	function get_all_menus($menuid) {
		//Untermenu raussuchen
		$sql=sprintf("SELECT menuid FROM %s WHERE untermenuzu='%s'",
		$this->cms->tbname['papoo_me_nu'],
		$menuid);
		$result=$this->db->get_results($sql);
		//print_r($result);
		if (!empty($result)){
			foreach ($result as $menu){

				$this->menuarray[]=$menu->menuid;
				$this->get_all_menus($menu->menuid);
			}
		}


	}

	/*
	* @return teaser Liste
	* @desc Artikel aus der Datenbank zur Teaser Liste bergeben...
	*/

	function make_teaser() {

		// Alle Menpunkte aus der Datenbank fischen, um die Linkaddresse bergeben zu knnen
		$selectlink= "SELECT * FROM ".$this->cms->papoo_menu."";
		// Daten in ein assoziatives Array einlesen
		$resultlink= $this->db->get_results($selectlink, ARRAY_A);
		// Resultate bergeben
		$result= $this->get_artikel($this->checked->menuid);

		//Wenn auch alle UNtermenpunkte angezeigt werden sollen
		//$result= $this->get_artikel_all($this->checked->menuid);

		$table_data= array ();
		$islink_ok= "ok";
		// bergeben des top_text Artikels auf der Startseite
		if (trim($this->cms->top_text) != '') { // Fge Text nur hinzu, wenn auch gesetzt. Fix by Martin Wegner, http://mroot.net/
			$textoben= $this->diverse->do_pfadeanpassen($this->cms->top_text)."\n";
		}
		$textoben= $this->diverse->do_pfadeanpassen($this->cms->top_text)."\n";
		if (($this->checked->menuid == 1 ) && $textoben) {
			// Daten fr den Toptext  zuweisen... ###
			array_push($table_data, array ('text' => $textoben,));
		}
		// Wenn nicht leer, dann bergeben
		if (!empty ($result)) {
			$lt_text= "";
			foreach ($result as $row) {
				// berschrift bereinigen
				$uberschrift= $row->header;
				if (empty($uberschrift))continue;

				// Wenn ein spezieller Text fr den teaser Link eingegeben wurde, diesen anzeigen

				if (trim($row->lan_teaser_link) == "") {
					$islink= $row->header;
				} else {
					$islink= $row->lan_teaser_link;
				}
				// endcodieren des HTMLS des Teaser-Bildes
				//$row->teaser_bild_html = $row->teaser_bild_html;
				// Korrektur fr korrektes HTML ... FIXME ...

				$textunter= "<p>".$row->lan_teaser."</p>";

				// fr die entsprechende id den Link heraussuchen
				$lt= $row->cattextid;
				foreach ($resultlink as $guck) {
					if ($lt == $guck['menuid']) {
						// Link wird bergeben (Bsp. index.php)
						$lt_text= $guck['menulink'];
					}
				}

				// edited by b.legt: Anpassung mod_rewrite
				// wenn mod_rewrite dann bearbeiten
				if ($this->cms->mod_rewrite == 2) {
					if (!empty ($lt_text)) {
						// .php wird entfernt FIXME fr andere Endungen
						$lt_text= eregi_replace(".php", "", $lt_text);
					}

				}
				// ENDE edited by b.legt

				// wenn die ANzahl der Kommentare pro Artikel angezeigt werden soll
				if ($this->cms->comment_yn == 2) {
					// Zuweisung fr das Template
					$commentok= 1;
					// Aus der Datenbank fischen
					$comment= $this->db->get_var("SELECT COUNT(*) FROM ".$this->cms->papoo_message." WHERE comment_article='$row->reporeID'");
				}
				// nicht erlaubt die Anzahl der KOmmentare zu zeigen
				else {
					$comment= "";
					$commentok= "";
				}
				// Die Artikel sollen nicht nur als teaser sondern komplett auf der Startseite angezeigt werden
				if ($this->cms->artikel_lang_yn == 2) {
					// Artikel-Text anfgen
					$textunter .= $this->diverse->do_pfadeanpassen($row->lan_article);
					// Link zu Artikel entfernen
					$islink= false;
				}
				// Wenn mod_rewrite, dann die Adress der images ndern!
				// edited by b.legt: Anpassung an Istallation in Unterverzeichnis
				if ($this->cms->mod_rewrite == "2") {
					//$textunter = eregi_replace("\./images", $this->cms->webverzeichnis."/images", $textunter);
					$textunter= $this->diverse->do_pfadeanpassen($textunter);
					$row->teaser_bild_html= $this->diverse->do_pfadeanpassen($row->teaser_bild_html);
				}
				// nochmal bereinigen
				//$textunter = stripslashes($textunter);
				// Daten zuweisen
				array_push($table_data, array (
				'text' => $textunter,
				'islink' => $islink,
				'islink_ok' => $islink_ok,
				'uberschrift' => $uberschrift,
				'reporeid' => $row->reporeID,
				'comment' => $comment,
				'comment_ok' => $commentok,
				'cattextid' => $row->cattextid,
				'islinktext' => $this->content->template['message_2144'],
				'linktext' => $lt_text,
				'teaserbild'=>$row->teaser_bild_html,
				));

			}

		}
		//print_r($table_data);
		// Daten zurckgeben
		return $this->list_start= $table_data;

	}

	/**
	* @return void
	* @desc Hiermit wird die Druckausgabe eines Artikels erzeugt.
	*/
	function make_print() {

		// Verarbeitung
		$this->content->template['comment_data']= array ();
		$table_data= array ();
		// Gast Name
		$username_comment= "Gast";

		// Kommentare zu diesem Artikel raussuchen
		if ($this->checked->forumid == 20) {
			$sql= "SELECT * FROM ".$this->cms->papoo_message." WHERE forumid='20' ORDER BY zeitstempel ASC ";
		} else {
			$sql= "SELECT * FROM ".$this->cms->papoo_message." WHERE comment_article=".$this->db->escape($this->checked->reporeid_print)." ORDER BY zeitstempel ASC ";
		}
		//echo $sql;
		$sqlcomment= $this->db->get_results($sql);
		//print_r($sqlcomment);
		// wenn nicht leer,
		if (!empty ($sqlcomment)) {
			// Setzen frs Template -> Kommentare vorhanden
			$this->content->template['comment_ok']= "ok";
			// fr jeden Eintrag
			foreach ($sqlcomment as $rowcom) {
				// bergeben und parsen$this->bbcode->parse(
				$messagetextcom= $rowcom->messagetext;
				// Username des Eintrags raussuchen
				$sqlgetuser= $this->db->get_results("SELECT username FROM ".$this->cms->papoo_user." WHERE userid=$rowcom->userid LIMIT 1");
				// Username zuweisen , wenn nicht leer
				if (!empty ($this->checked->sqlgetuser)) {
					foreach ($this->checked->sqlgetuser as $rowusercom) {
						$username_comment= $rowusercom->username;
					}
				}
				// Daten in ein Array suweisen
				array_push($this->content->template['comment_data'], array ('text' => $messagetextcom, 'zeitstempel' => $rowcom->zeitstempel, 'thema' => $rowcom->thema, 'username_comment' => $username_comment));
			}
		}
		// Artikel raussuchen mit Kontrolle
		$select= "SELECT * FROM ".$this->cms->papoo_repore.",".$this->cms->papoo_language_article." WHERE";
		$select .= " publish_yn='1' AND publish_yn_intra='0' AND allow_publish='1'  ";
		$select .= " AND reporeID LIKE '".$this->db->escape($this->checked->reporeid_print)."' AND reporeID=lan_repore_id AND lang_id='".$this->cms->lang_id."' ";
		$select .= "  ORDER BY reporeID DESC"; // Abfrage zur Datenbank
		$result= $this->db->get_results($select);
		// Wenn ein Eintrag vorhanden ist, setzen
		if (!empty ($result)) {
			$this->content->template['eintrag']= '1';
		}
		$this->content->template['article']= '1';
		// Eintrge zuweisen
		if (!empty ($result)) {
			foreach ($result as $roweins) {
				$dokuser= $roweins->dokuser;
				// Autornamen raussuchen
				$queryuser= "SELECT * FROM ".$this->cms->papoo_user." WHERE userid=$dokuser";
				$resultusi= $this->db->get_results($queryuser);
				if (!empty ($resultusi)) {
					foreach ($resultusi as $rowuser) {
						$this->content->template['author']= $rowuser->username;
						$this->content->template['usernameid']= $rowuser->userid;
					}
				}
				// HTML erzeugen
				$texteins= $roweins->lan_article;
				// Links etc. aus dem Text fischen und unten dranhngen
				$texteins= $this->replace->do_print($texteins);
				// mit dem Teaser zusammenlegen, aber nur wenn auch was im Teaser drin ist.
				if (!empty ($roweins->lan_teaser)) {
					$texteins= "<p>".$roweins->lan_teaser."</p>".$texteins;
				} else {
					$texteins= $texteins;
				}

				$islinkmehr= $roweins->header;

				$title= $this->cms->title." ".$islinkmehr;
				$this->content->template['comment_title']= $islinkmehr;
				array_push($table_data, array ('islink' => $islinkmehr, 'text' => $this->diverse->do_pfadeanpassen($texteins), 'zeitstempel' => $roweins->timestamp,));
				$this->content->template['table_data']= $table_data;
			}
		}
	}
	/**
	 * @abstract Hier wird festgestellt ob ein Artikel im Frontend editiert werden darf.
	 * Dabei wird mit der reporeid gesucht und mit den Rechten gegengecheckt.
	 * Wenn alles positiv ist kommt ein edit Button im Frontend beim Artikel
	 *
	 */
	function check_edit($editnr){
		$sql="";
		//rausholen ob der Artikel schreibrechte hat
		if ($this->user->username == "root") {
			//$sql=sprintf("SELECT reporeID FROM %s WHERE AND reporeID='%s' ", // !!! edit b.legt: SQL Fehler
			$sql=sprintf("SELECT reporeID FROM %s WHERE reporeID='%d' ",
			$this->cms->papoo_repore,
			$editnr);
		}
		else
		{
			//checken ob der User berhaupt schreiben bzw. zugreifen darf
			$this->user->extern="1";
			$ok=$this->user->check_intern();
			//Wenn ja, dann raussuchen
			if ($ok=="ok"){
				$sql=sprintf("SELECT reporeID FROM %s WHERE dokuser='%s' AND reporeID='%s' OR reporeID='%s' AND  dokschreibengrid='1'",
				$this->cms->papoo_repore,
				$this->user->userid,
				$this->db->escape($editnr),
				$this->db->escape($editnr));
			}

		}

		if (!empty($sql)){
			$repo=$this->db->get_var($sql);

			if (!empty($repo)){
				global $webverzeichnis;
				$this->content->template['editlink']=$webverzeichnis."/interna/artikel.php?menuid=11&reporeid=".$repo."&from=front";
			}
		}

	}

}
$artikel= new artikel();
?>
